/*
Find ramification of carbon chain
Copyright (C) 2004  Lotfi BAGHLI

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
//---------------------------------------------------------------------------
//#define debuglotfi

#include <vcl.h>
#pragma hdrstop

#include "carbone.h"
#include "Dessine.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCarboneForm *CarboneForm;
//---------------------------------------------------------------------------

__fastcall TCarboneForm::TCarboneForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::ChercheCollegue(int r)
{
int ih;          // important que ces variables soient locales
bool Trouve;     // car fonction rentrante !
Liaison * LM, * Lnew;
TList * ch;
  Trouve=false;
  for (ih=0; ih<Nl; ih++)
          {
          LM=(Liaison *)Molecule->Items[ih];
          if ( r==LM->d && !LM->s )
                                        {
                                        LM->s=1;    // liaison utilise ds un sens
                                        Trouve=true;
                                        OnAvance=true;
                                        Pile++;
                                        Lnew=new Liaison;
                                        Lnew->d=LM->d;
                                        Lnew->f=LM->f;  // s inutile
                                        Chemin->Add(Lnew);
                                        ChercheCollegue( LM->f);
                                        Trouve=false;
                                       }
          if ( r==LM->f && !LM->s )   // ds l'autre sens
                                        {
                                        LM->s=2;    // liaison utilise ds l'autre sens
                                        Trouve=true;
                                        OnAvance=true;
                                        Pile++;
                                        Lnew=new Liaison;
                                        Lnew->d=LM->f;
                                        Lnew->f=LM->d;  // s inutile
                                        Chemin->Add(Lnew);
                                        ChercheCollegue( LM->d);
                                        Trouve=false;
                                       }
          }
  if (!Trouve)  { // fin du parcourt d'une ramification
                if (OnAvance) {// Sauve la trouvaille
                              OnAvance=false;
                              ch=new TList();
                              ch->Assign( Chemin, laCopy);
                              LesChemins->Add(ch);
                              AfficheLiaisons(ch);
                              }
                Pile--;
                if (Pile>=0) Chemin->Delete( Chemin->Count-1);
                }
 }

//---------------------------------------------------------------------------

//  Routine de recherche de toutes les chaines
void __fastcall TCarboneForm::ChercheTous()     // radical
{
Liaison * LM;
  for (i=0; i<Nl; i++)
    {
    LM=(Liaison *)Molecule->Items[i];
    LM->s=0;    // liaison non used
    }
  Pile=0;
  if (!Chemin)  Chemin=new TList();
        else    {
                for (i=0; i<Chemin->Count; i++)
                      delete Chemin->Items[i];
                Chemin->Clear();
                }
  // attaque la bte !
	ChercheCollegue( radical);
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::FormShow(TObject *Sender)
{
  MemoOut->Lines->Clear();
  MemoOut->Lines->Append("Bienvenue dans le ramificateur :-)\n");
  RD11Click(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::AfficheLiaisons( TList * ch)
{
Liaison * L;
  MemoLine="";
  for (i=0; i<ch->Count; i++)
    {
    L=(Liaison *)ch->Items[i];
    MemoLine+=IntToStr(L->d)+'-'+IntToStr(L->f)+"  ";
    }
  MemoOut->Lines->Append(MemoLine);
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::ButtonCalculeClick(TObject *Sender)
{
  MemoOut->Lines->Append("");
  radical=StrToInt( Editrc->Text);
  switch (PageControl->TabIndex)
    {
    case 0 :  MemoOut->Lines->Append("Nouvelle recherche  partir de "+Editrc->Text
                                      +", Manuel input");
              break;
    case 1 :  MemoOut->Lines->Append("Nouvelle recherche  partir de "+Editrc->Text
                                      +", Selected input");
              break;
    }
  if (!LesChemins)  LesChemins=new TList();
        else        {
                    for (i=0; i<LesChemins->Count; i++)
                      {
                      for (int j=0; j<((TList *)LesChemins->Items[i])->Count; j++)
                          delete ((TList *)LesChemins->Items[i])->Items[j];
                      delete LesChemins->Items[i];
                      }
                    LesChemins->Clear();
                    }
  MemoOut->Lines->Append("___Ramifications :");
  ChercheTous();
}
//---------------------------------------------------------------------------
void __fastcall TCarboneForm::ButtonLoadDataClick(TObject *Sender)
{
// charge depuis le MemoDataIn
  Nc=StrToInt( EditNc->Text);
  Nl=StrToInt( EditNl->Text);
  ReadData(MemoDataIn);
}
//---------------------------------------------------------------------------
void __fastcall TCarboneForm::ReadData(TMemo *Memo)
{
// charge depuis le MemoDataIn ou le selectedMemo
Liaison * L;
int Nlhere;
char * p, SS[500];
AnsiString Control="";
  if (Molecule) {
                for (i=0; i<Molecule->Count; i++)
                  delete Molecule->Items[i];
                delete Molecule;
                }
  Molecule=new TList;
  // lecture des datas
  strcpy( SS, Memo->Lines->Text.c_str());
  p = strtok(SS, " ,\n\r");
  if (!p) {
          Application->MessageBox( "Verifiez vos donnes", "Data input error",
                                MB_OK+MB_ICONSTOP);
          return;
          }
  Nlhere=1;
  L=new Liaison;
  Control+=AnsiString(p)+".";
  L->d=atoi(p);
  p = strtok(NULL, " ,\n\r");
  if (!p) {
          Application->MessageBox( "Verifiez vos donnes", "Data input error",
                                MB_OK+MB_ICONSTOP);
          return;
          }
  Control+=AnsiString(p)+".";
  L->f=atoi(p);
  L->s=0;
  Molecule->Add(L);
	do	{
		p = strtok(NULL, " ,\n\r");
		if (!p) break;
    Nlhere++;
    L=new Liaison;
    Control+=AnsiString(p)+".";
    L->d=atoi(p);
		p = strtok(NULL, " ,\n\r");
		if (!p) break;
    Control+=AnsiString(p)+".";
    L->f=atoi(p);
    L->s=0;
    Molecule->Add(L);
		} while(p);
/*
  Control+="\nLiaison="+IntToStr(Nlhere);
  Application->MessageBox( Control.c_str(), "Data Error",
                                MB_OK+MB_ICONSTOP);
*/                                
  if (Nl!=Nlhere || Nlhere!=Molecule->Count) {
          Application->MessageBox( "Nombre de liaisons incorrecte", "Data Error",
                                MB_OK+MB_ICONSTOP);
          return;
          }
  MemoOut->Lines->Append("");
  MemoOut->Lines->Append("Affiche liaisons existantes de la molcule");
  AfficheLiaisons( Molecule);
}
//---------------------------------------------------------------------------


void __fastcall TCarboneForm::RD11Click(TObject *Sender)
{
  if (!RD11->Checked) return;
  MemoSelectedData->Lines->Clear();
  MemoSelectedData->Lines->Append("1 2");
  MemoSelectedData->Lines->Append("2 3");
  MemoSelectedData->Lines->Append("3 4");
  MemoSelectedData->Lines->Append("4 5, 4 8");
  MemoSelectedData->Lines->Append("5 6");
  MemoSelectedData->Lines->Append("6 7, 6 9");
  MemoSelectedData->Lines->Append("8 10");
  MemoSelectedData->Lines->Append("10 11");
  EditSNc->Text="11";
  EditSNl->Text="10";
  Editrc->Text="1";
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::ButtonLoadSelectedDataClick(TObject *Sender)
{
// charge depuis le MemoDataIn
  Nc=StrToInt( EditSNc->Text);
  Nl=StrToInt( EditSNl->Text);
  ReadData(MemoSelectedData);
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::RD15Click(TObject *Sender)
{
  if (!RD15->Checked) return;
  MemoSelectedData->Lines->Clear();
  MemoSelectedData->Lines->Append("1 2");
  MemoSelectedData->Lines->Append("2 3");
  MemoSelectedData->Lines->Append("3 4, 3 8");
  MemoSelectedData->Lines->Append("4 5");
  MemoSelectedData->Lines->Append("5 6, 5 11");
  MemoSelectedData->Lines->Append("6 7");
  MemoSelectedData->Lines->Append("8 9");
  MemoSelectedData->Lines->Append("9 10");
  MemoSelectedData->Lines->Append("11 12");
  MemoSelectedData->Lines->Append("12 13, 12 14");
  MemoSelectedData->Lines->Append("14 15");
  EditSNc->Text="15";
  EditSNl->Text="14";
  Editrc->Text="11";
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::CBAfficheDessinClick(TObject *Sender)
{
  switch(CBAfficheDessin->Checked)
    {
    case (true):
        if (Nc==0)  {
                    Application->MessageBox( "Donnes non charges ", "Data Error",
                                MB_OK+MB_ICONSTOP);
                    CBAfficheDessin->Checked=false;
                    return;
                    }
        if (DessineMolecule) {
                for (i=0; i<DessineMolecule->Count; i++)
                  delete DessineMolecule->Items[i];
                delete DessineMolecule;
                }
        DessineMolecule=new TList;
//        FormDessin->Visible=true;
        TreeView->Visible=true;
        Splitter1->Visible=true;
        ElaboreDessin();
        FormDessin->Invalidate();
        break;
    case (false):
//        FormDessin->Visible=false;
        TreeView->Visible=false;
        Splitter1->Visible=false;
        break;
    }
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::ElaboreDessin()
{
Atome * A, * B;
Liaison * LM;
  for (i=0; i <= Nc; i++)   // le 0 ziyada
    {
    A=new Atome;
    A->x=1000; A->y=1000;
    A->l1=0; A->l2=0; A->l3=0; A->l4=0;
    A->noue=false;
    DessineMolecule->Add( A);
    }
  for (i=1; i <= Nc; i++)
    {
    A=(Atome*)DessineMolecule->Items[i];
    for (int j=0; j<Nl; j++)
      {
      LM=(Liaison*)Molecule->Items[j];
      if (LM->d==i &&               // apres || LM->f==i
          (A->l1 !=LM->f || A->l2 !=LM->f || A->l3 !=LM->f || A->l4 !=LM->f))
           {
           if (!A->l1)    {
                          A->l1=LM->f;
                          B=(Atome*)DessineMolecule->Items[A->l1];
                          if (B->l1 !=i || B->l2 !=i || B->l3 !=i || B->l4 !=i)
                            {
                            if (!B->l2)  B->l2=i;
                            else  {if (!B->l3)  B->l3=i;
                                  else  {if (!B->l4)  B->l4=i;}}
                            }
                          }
           else  if (!A->l2)    {
                                A->l2=LM->f;
                                B=(Atome*)DessineMolecule->Items[A->l2];
                                if (B->l1 !=i || B->l2 !=i || B->l3 !=i || B->l4 !=i)
                                  {
                                  if (!B->l1)  B->l1=i;
                                  else  {if (!B->l3)  B->l3=i;
                                        else  {if (!B->l4)  B->l4=i;}}
                                  }
                                }
                      else  if (!A->l3)   {
                                          A->l3=LM->f;
                                          B=(Atome*)DessineMolecule->Items[A->l3];
                                          if (B->l1 !=i || B->l2 !=i || B->l3 !=i || B->l4 !=i)
                                            {
                                            if (!B->l4)  B->l4=i;
                                            else  {if (!B->l1)  B->l1=i;
                                                  else  {if (!B->l2)  B->l2=i;}}
                                            }
                                          }
                            else  if (!A->l4)   {
                                                A->l4=LM->f;
                                                B=(Atome*)DessineMolecule->Items[A->l4];
                                                if (B->l1 !=i || B->l2 !=i || B->l3 !=i || B->l4 !=i)
                                                  {
                                                  if (!B->l3)  B->l3=i;
                                                  else  {if (!B->l1)  B->l1=i;
                                                        else  {if (!B->l2)  B->l2=i;}}
                                                  }
                                                }
           }
      }
  }
#ifdef debuglotfi
  MemoOut->Lines->Append("Debug Liaions");
  for (i=1; i <= Nc; i++)
    {
    A=(Atome*)DessineMolecule->Items[i];
    MemoLine="C"+IntToStr(i);
    MemoLine+=" liaisons :  l1 "+IntToStr(A->l1)+"  l2 "+IntToStr(A->l2)
              +"  l3 "+IntToStr(A->l3)+"  l4 "+IntToStr(A->l4);
    MemoOut->Lines->Append(MemoLine);
    }
#endif

// sort sur le treeview
  TreeView->Items->Clear();
  TTreeNode * noeud=TreeView->Items->Add(NULL, "C1");
  noeud->Expand(true);
  A=(Atome*)DessineMolecule->Items[1];
  if (A->l1) Recherchenoeud( 1, A->l1, noeud);
  if (A->l2) Recherchenoeud( 1, A->l2, noeud);
  if (A->l3) Recherchenoeud( 1, A->l3, noeud);
  if (A->l4) Recherchenoeud( 1, A->l4, noeud);
  TreeView->FullExpand();

// recherche les postions  partir de l'atome 1 (le 0 n'existe pas)
  A=(Atome*)DessineMolecule->Items[1];
  A->x=0; A->y=0;
  if (A->l1) RecherchePosition( 1, A->l1);
  if (A->l2) RecherchePosition( 1, A->l2);
  if (A->l3) RecherchePosition( 1, A->l3);
  if (A->l4) RecherchePosition( 1, A->l4);
  A=(Atome*)DessineMolecule->Items[1];
  A->x=0; A->y=0;
  if (A->l1) RecherchePosition( 1, A->l1);
  if (A->l2) RecherchePosition( 1, A->l2);
  if (A->l3) RecherchePosition( 1, A->l3);
  if (A->l4) RecherchePosition( 1, A->l4);


#ifdef debuglotfi
  MemoOut->Lines->Append("Debug Coordonnes");
  for (i=1; i <= Nc; i++)
    {
    A=(Atome*)DessineMolecule->Items[i];
    MemoLine="C"+IntToStr(i)+" Pos x="+IntToStr(A->x)+" y="+IntToStr(A->y);
    MemoLine+=" liaisons :  l1 "+IntToStr(A->l1)+"  l2 "+IntToStr(A->l2)
              +"  l3 "+IntToStr(A->l3)+"  l4 "+IntToStr(A->l4);
    MemoOut->Lines->Append(MemoLine);
    }
#endif
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::Recherchenoeud(int d, int f, TTreeNode * noeud)
{
Atome * Ad, * Af;
  Ad=(Atome*)DessineMolecule->Items[d];
  Af=(Atome*)DessineMolecule->Items[f];
  Ad->noue=true;
  if ((Af->l1 || Af->l2 || Af->l3 || Af->l4) && !Af->noue)
      {
//      TTreeNode * noeudf=TreeView->Items->Add(NULL, "C"+IntToStr(f));
  TTreeNode * noeudf=TreeView->Items->AddChild(noeud , "C"+IntToStr(f));
      Recherchenoeud( f, Af->l1, noeudf);
      Recherchenoeud( f, Af->l2, noeudf);
      Recherchenoeud( f, Af->l3, noeudf);
      Recherchenoeud( f, Af->l4, noeudf);
      }
}

void __fastcall TCarboneForm::RecherchePosition(int d, int f)
{
Atome * Ad, * Af;
  Ad=(Atome*)DessineMolecule->Items[d];
  Af=(Atome*)DessineMolecule->Items[f];
  if (Af->l2)   {
                if (Af->l2==d)  {if (Af->x==1000 && Ad->y!=1000)
                                              {
                                              Af->x=Ad->x+1;
                                              Af->y=Ad->y;
                                              }
                                }
                else  RecherchePosition( f, Af->l2);
                }
  if (Af->l1)   {
                if (Af->l1==d)  {if (Af->x==1000 && Ad->y!=1000)
                                              {
                                              Af->x=Ad->x-1;
                                              Af->y=Ad->y;
                                              }
                                }
                else  RecherchePosition( f, Af->l1);
                }
  if (Af->l3)   {
                if (Af->l3==d)  {if (Af->y==1000 && Ad->x!=1000)
                                              {
                                              Af->x=Ad->x;
                                              Af->y=Ad->y+1;
                                              }
                                }
                else  RecherchePosition( f, Af->l3);
                }
  if (Af->l4)   {
                if (Af->l4==d)  {if (Af->y==1000 && Ad->x!=1000)
                                              {
                                              Af->x=Ad->x;
                                              Af->y=Ad->y-1;
                                              }
                                }
                else  RecherchePosition( f, Af->l4);
                }
}
//---------------------------------------------------------------------------

void __fastcall TCarboneForm::Dessine()
{
// est appel par le TFormDessin::FormPaint
Atome * Ad, * Af;
Liaison * LM;
int d, f,
    x0=40, y0=40,
    Pas=30;
   for (i=0; i<Nl; i++)
      {
      LM=(Liaison*)Molecule->Items[i];
      d=LM->d;
      f=LM->f;
      Ad=(Atome*)DessineMolecule->Items[d];
      Af=(Atome*)DessineMolecule->Items[f];
      FormDessin->Canvas->MoveTo( Ad->x*Pas+x0, Ad->y*Pas+y0);
      FormDessin->Canvas->LineTo( Af->x*Pas+x0, Af->y*Pas+y0);
      SetTextAlign( FormDessin->Canvas->Handle, TA_CENTER);;
      FormDessin->Canvas->TextOut( Ad->x*Pas+x0, Ad->y*Pas+y0, IntToStr(d));
      FormDessin->Canvas->TextOut( Af->x*Pas+x0, Af->y*Pas+y0, IntToStr(f));
      }
}
//---------------------------------------------------------------------------


